//+------------------------------------------------------------------+
//|                                            Copyist positions.mq4 |
//|                                                            Urain |
//|                               http://www.mql4.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Urain"
#property link      "http://www.mql4.com/ru/users/Urain"
#property show_inputs
extern double koeff_lot=1.0; //    
int delay_time=500;  //  
int  cnt_command=0;  //  
int  TotalSymbols;   //  
string Symbols[];    //  
double SymPosVol[];  //     
int    SymPosType[]; //   ,    -1
double SymPosSL[];   //     
double SymPosTP[];   //     
//---  
double realSymPosVol[];  //       
int    realSymPosType[]; //     ,    -1
double realSymPosSL[];   //       
double realSymPosTP[];   //       
int Size=0; //      ,       
string s[]; //    
//+------------------------------------------------------------------+
//|  Script program start function                                   |
//+------------------------------------------------------------------+
int start()
  {
//---       
   Size=READS("Translator positions",s,true);
   ArrayResize(Symbols,Size);
//---       
   for(int i=1;i<Size;i++)parser_string_Symbols(i);
   string com0="";//       
   for(i=1;i<Size;i++)//      
     {
      if(bid(Symbols[i])==0)
        {
         //---               
         com0=com0+"["+Symbols[i]+"] ";
         Symbols[i]="";
        }
     }
//---       
   if(com0!="")com0="    "+com0+"\n";

//---   
   ArrayResize(SymPosVol,Size);
   ArrayResize(SymPosType,Size);
   ArrayResize(SymPosSL,Size);
   ArrayResize(SymPosTP,Size);

   ArrayResize(realSymPosVol,Size);
   ArrayResize(realSymPosType,Size);
   ArrayResize(realSymPosSL,Size);
   ArrayResize(realSymPosTP,Size);

//---  ,       
   while(!IsStopped())
     {
      if(Busy_and_Connected())//       
        {
         READS("Translator positions",s,false);
         if(cnt_command!=StrToInteger(s[0]))
           {
            //---    ,                 
            cnt_command=parser(Size);
            //---      +                
            string com=com0+s[0];
            //---    
            for( i=1;i<Size;i++)
               com=com+"\n"+Symbols[i]+"  [ "+DoubleToStr(SymPosVol[i],DigitsMinLot(Symbols[i]))+" ]  [ "+SymPosType[i]+" ]  [ "+
                   DoubleToStr(SymPosSL[i],digits(Symbols[i]))+" ]  [ "+
                   DoubleToStr(SymPosTP[i],digits(Symbols[i]))+" ]";
            //---  
            Comment(com);
           }
         //---               
         int start=GetTickCount();
         //---                 
         if(compare_positions())processing_signals();
         //---             
         if(compare_sl_tp_levels())processing_sl_tp_levels();
         //---       
         int TickCount=GetTickCount()-start;
        }
      //---            
      if(delay_time>TickCount)Sleep(delay_time-TickCount);
     }
//---         
   Alert("end, Copyist positions ");
//---       
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+  
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+  
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
//---       MarketInfo
int digits(string symbol){return(MarketInfo(symbol,MODE_DIGITS));}
//---         MarketInfo
double point(string symbol){return(MarketInfo(symbol,MODE_POINT));}
//---       MarketInfo
double ask(string symbol){return(MarketInfo(symbol,MODE_ASK));}
//---       MarketInfo
double bid(string symbol){return(MarketInfo(symbol,MODE_BID));}
//---       MarketInfo
int spred(string symbol){return(MarketInfo(symbol,MODE_SPREAD));}
//---       MarketInfo
int stlevel(string symbol){return(MarketInfo(symbol,MODE_STOPLEVEL));}
//---        MarketInfo
double maxlot(string symbol){return(MarketInfo(symbol,MODE_MAXLOT));}
//---        MarketInfo
double minlot(string symbol){return(MarketInfo(symbol,MODE_MINLOT));}
//---  "v"       MarketInfo
double nd(string symbol,double v){return(NormalizeDouble(v,digits(symbol)));}
//---   "v"                    
double NDL(string symbol,double v){return(NormalizeDouble(v,DigitsMinLot(symbol)));}
//---           
double price_open(string symbol,int cmd) {if(cmd%2)return(bid(symbol));else return(nd(symbol,ask(symbol)));}
//---           
double price_close(string symbol,int cmd){if(cmd%2)return(ask(symbol));else return(nd(symbol,bid(symbol)));}
//---    
bool Busy_and_Connected(){if(IsTradeAllowed() && IsConnected())return(true);else return(false);}
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
int DigitsMinLot(string symbol)
  {
   double ml=MarketInfo(symbol,MODE_MINLOT);
//--- 1/x   
   double Dig=0;if(ml!=0)Dig=1.0/ml;
//---   1/x  digits
   double res=0;
   if(Dig>1)res=1;
   if(Dig>10)res=2;
   if(Dig>100)res=3;
   if(Dig>1000)res=4;
   return(res);
  }
//+------------------------------------------------------------------+
//|    .  .      |
//|  return             | 
//+------------------------------------------------------------------+
double ndlot(string symbol,double l)
  {
   double ml=minlot(symbol);
   double rez=NormalizeDouble(l/ml,0)*ml;
   double Maxlot=maxlot(symbol);
   if(rez>Maxlot)rez=Maxlot;
   return(NormalizeDouble(rez,DigitsMinLot(symbol)));
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
bool compare_positions()
  {
//---           
   real_pos_volum();
//---      
   for(int i=1;i<Size;i++)
     {
      //---       
      if(Symbols[i]=="")continue;
      //---       ,            
      if(NDL(Symbols[i],realSymPosVol[i])!=NDL(Symbols[i],SymPosVol[i])){return(true);}
      //---       ,       
      if(realSymPosType[i]!=SymPosType[i]){return(true);}
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                     |
//+------------------------------------------------------------------+
void real_pos_volum()
  {
//---     
   ArrayInitialize(realSymPosVol,0.0);
   ArrayInitialize(realSymPosType,-1);
//---    
   int Total=OrdersTotal();
//---   
   for(int i=0;i<Total;i++)
     {
      //---   
      if(OrderSelect(i,SELECT_BY_POS))
        {
         //---      
         int Type=OrderType();
         //---    
         if(Type%2==Type)
           {
            //---       
            string symbol=OrderSymbol();
            //---      
            for(int j=1;j<Size;j++)
              {
               //---         
               if(symbol==Symbols[j])
                 {
                  //---        ,     -1,+1                  
                  realSymPosVol[j]+=NDL(symbol,OrderLots()*(Type*2-1));
                 }
              }
           }
        }
     }
//---            
   for(i=1;i<Size;i++)
     {
      //---             
      if(Symbols[i]=="")continue;
      //---     , 
      //---      
      if(realSymPosVol[i]!=0)
        {
         //---       
         realSymPosType[i]=(realSymPosVol[i]/MathAbs(realSymPosVol[i])+1)/2;
         //---      
         realSymPosVol[i]=MathAbs(realSymPosVol[i]);
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
void processing_signals()
  {
   while(!IsStopped())
     {
      //---     
      if(Busy_and_Connected())
        {
         //---            
         for(int i=1;i<Size;i++)
           {
            //---                 
            if(Symbols[i]=="")continue;
            //---         -1,+1            
            int TF=SymPosType[i]*2-1;
            //---       -1,+1
            int TR=realSymPosType[i]*2-1;
            //---                           
            double VF=SymPosVol[i];
            //---     
            double VR=realSymPosVol[i];
            double lot;
            //---       
            if(NormalizeDouble(VF*TF,8)!=NormalizeDouble(VR*TR,8))
              {
               //---           
               //---                                        
               if((VR!=0 && TF!=TR) || (TF==TR && VF<VR))
                 {
                  //---           
                  if(TF==TR && VF<VR)lot=realSymPosVol[i]-SymPosVol[i];
                  //---          
                  else lot=realSymPosVol[i];
                  //---    ,                      
                  close_market_order(Symbols[i],lot);
                  break;
                 }
               else
                 {
                  //---           
                  if(TF==TR && VF>VR)lot=SymPosVol[i]-realSymPosVol[i];
                  //---                           
                  else lot=SymPosVol[i];
                  //---    ,     
                  open_market_order(Symbols[i],SymPosType[i],lot);
                  break;
                 }
              }
            else
              {
               //---       
               //---       
               if(!IsTradeAllowed())break;
              }
           }
        }
      //---        
      else Comment("     ");
      //---             
      if(!compare_positions())break;
     }
   return;
  }  
//+------------------------------------------------------------------+
//|                          |
//|                                |
//+------------------------------------------------------------------+
void close_market_order(string symbol,double lot)
  {
//---     
   bool FlagLot=true;
//---    
   int Total=OrdersTotal();
//---   
   for(int i=0;i<Total;i++)
     {
      //---   
      if(OrderSelect(i,SELECT_BY_POS))
        {
         //---    
         if(OrderType()%2==OrderType())
           {
            //---       
            if(symbol==OrderSymbol())
              {
               //---          
               if(OrderLots()==ndlot(symbol,lot))
                 {
                  //---                     
                  Closes(symbol,OrderTicket(),lot);
                  //---    ,                      
                  FlagLot=false;
                  break;
                 }
              }
           }
        }
     }
//---             
//---        
   if(FlagLot)
     {
      //---   
      for(i=0;i<Total;i++)
        {
         //---   
         if(OrderSelect(i,SELECT_BY_POS))
           {
            //---    
            if(OrderType()%2==OrderType())
              {
               //---       
               if(symbol==OrderSymbol())
                 {
                  //---     ,    
                  Closes(symbol,OrderTicket(),lot);
                  break;
                 }
              }
           }
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
bool compare_sl_tp_levels()
  {
//---        
   real_pos_sl_tp_levels();
//---       
   for(int i=1;i<Size;i++)
     {
      //---              
      if(Symbols[i]=="")continue;
      //---  ,            
      if(nd(Symbols[i],realSymPosSL[i])!=nd(Symbols[i],SymPosSL[i])){return(true);}
      //---  ,       
      if(nd(Symbols[i],realSymPosTP[i])!=nd(Symbols[i],SymPosTP[i])){return(true);}
     }
//---                  
   return(false);
  }
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
void real_pos_sl_tp_levels()
  {
//---      
   ArrayInitialize(realSymPosSL,0.0);
   ArrayInitialize(realSymPosTP,0.0);
//---       
   int Total=OrdersTotal();
//---      
   for(int i=0;i<Total;i++)
     {
      //---        
      if(OrderSelect(i,SELECT_BY_POS))
        {
         //---              
         int Type=OrderType();
         //---             
         if(Type%2==Type)
           {
            //---                  
            string symbol=OrderSymbol();
            //---                 
            for(int j=1;j<Size;j++)
              {
               //---                       
               if(symbol==Symbols[j])
                 {
                  //---      -EMPTY_VALUE                  
                  if(NormalizeDouble(OrderStopLoss(),digits(symbol))!=SymPosSL[j])
                     realSymPosSL[j]=-EMPTY_VALUE;
                  else
                    {
                     //---   -EMPTY_VALUE                          
                     if(realSymPosSL[j]!=-EMPTY_VALUE)realSymPosSL[j]=SymPosSL[j];
                    }
                  //---      -EMPTY_VALUE  
                  if(NormalizeDouble(OrderTakeProfit(),digits(symbol))!=SymPosTP[j])
                     realSymPosTP[j]=-EMPTY_VALUE;
                  else
                    {
                     //---   -EMPTY_VALUE     
                     if(realSymPosTP[j]!=-EMPTY_VALUE)realSymPosTP[j]=SymPosTP[j];
                    }
                 }
              }
           }
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void modification_sl_tp_levels()
  {
//---    
   int Total=OrdersTotal();
//---    
   for(int i=0;i<Total;i++)
     {
      //---  
      if(OrderSelect(i,SELECT_BY_POS))
        {
         //---     
         int Type=OrderType();
         //---      
         if(Type%2==Type)
           {
            //---       
            string symbol=OrderSymbol();
            //---      
            for(int j=1;j<Size;j++)
              {
               //---         
               if(symbol==Symbols[j])
                 {
                  //---   SL  TP      
                  if(NormalizeDouble(OrderStopLoss(),digits(symbol))!=SymPosSL[j] || 
                     NormalizeDouble(OrderTakeProfit(),digits(symbol))!=SymPosTP[j]
                     )
                    {
                     //---   ,                          
                     OrderTradeModif(OrderTicket(),symbol,Type,OrderOpenPrice(),SymPosSL[j],SymPosTP[j]);
                     break;
                    }
                 }
              }
           }
        }
     }
  }  
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void processing_sl_tp_levels()
  {
//---        
   int start=GetTickCount();
   while(!IsStopped())
     {
      //---     
      if(Busy_and_Connected())
        {
         //---                
         modification_sl_tp_levels();
        }
      //---          
      if(GetTickCount()-start>delay_time)READS("Translator positions",s,false);
      //---               
      if(cnt_command!=StrToInteger(s[0]))break;
      //---       
      Sleep(50);
      //---               
      if(!compare_sl_tp_levels())break;
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+  
//+------------------------------------------------------------------+
//|                    |
//|                                |
//+------------------------------------------------------------------+
bool Closes(string symbol,int ticket,double lot)
  {
//---         
   double Lots=OrderLots();
//---         ..   
   if(Lots>lot)Lots=ndlot(symbol,lot);
//---              
   if(OrderType()>1 || Lots<=0)return;
//---          
   if(!OrderClose(ticket,Lots,price_close(OrderSymbol(),OrderType()),spred(OrderSymbol())))
     {
      //---        false      
      Print(" _() ",GetLastError());
      return(false);
     }
   return(true); //     true
  }
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+
bool OrderTradeModif(int ticket,string symbol,int cmd,double price,double stoploss=0,double takeprofit=0,int magic=0)
  {
//---    
   double Stoploss,Takeprofit;
//---     -      
   bool flag=false;

//---     
   if(stoploss!=0)
     {
      //---         
      if((stoploss>price && !cmd) || 
         (stoploss<price && cmd)
         )Stoploss=takeprofit; else Stoploss=stoploss;
      //---                  
      if(MathAbs(price_close(symbol,cmd)-Stoploss)<stlevel(symbol)*point(symbol))
         Stoploss=OrderStopLoss();
     }
   if(takeprofit!=0)
     {
      //---         
      if((takeprofit<price && !cmd) || 
         (takeprofit>price && cmd)
         )Takeprofit=stoploss; else Takeprofit=takeprofit;
      //---             
      if(MathAbs(price_close(symbol,cmd)-Takeprofit)<stlevel(symbol)*point(symbol))
         Takeprofit=OrderTakeProfit();
     }
//---   ,       
   if(Stoploss==OrderStopLoss() && Takeprofit==OrderTakeProfit())return(false);
   else return(OrderModify(ticket,price,Stoploss,Takeprofit,NULL));
  }
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
int open_market_order(string symbol,int cmd,double volume,int stoploss=0,int takeprofit=0,int magic=0)
  {
//---     
   int direction=((cmd%2)*2)-1,Cmd=cmd;
   double Stoploss=0,Takeprofit=0,Price;

//---   
   if(cmd<2)//    
      Price=price_open(symbol,cmd);

//---     SL  TP   
/*   if(stoploss!=0 && stoploss<stlevel(symbol))Stoploss=stlevel(symbol);
   if(takeprofit!=0 && takeprofit<stlevel(symbol))Takeprofit=stlevel(symbol);
   
   if(stoploss!=0)
      Stoploss=nd(symbol,Price+Stoploss*point(symbol)*direction);
   else Stoploss=0;

   if(takeprofit!=0)
      Takeprofit=nd(symbol,Price-Takeprofit*point(symbol)*direction);
   else Takeprofit=0; */

//---    . . 
   double lot=ndlot(symbol,volume);
   if(lot==0)return(-1);

//---  
   int ticket=OrderSend(symbol,Cmd,lot,Price,spred(symbol),Stoploss,Takeprofit,NULL,magic);

//---   
   if(ticket>-1)return(ticket);
   else Print(" _() ",GetLastError());
  }
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
int READS(string files,string &s[],bool resize)
  {
//---       
   int handle=FileOpen(files+".csv",FILE_CSV|FILE_READ,";");
//---    
   if(handle>0)
     {
      //---              
      if(resize)ArrayResize(s,1);
      int cnt=0;
      while(true)//  c    break
        {
         //---                           
         if(resize)ArrayResize(s,cnt+1);
         s[cnt]=FileReadString(handle);  //     
         FileSeek(handle,0,SEEK_CUR);    //      
         if(s[cnt]=="")break; //          
         cnt++;
        }
      ArrayResize(s,cnt);
      FileClose(handle);
     }
//---     
   else Print("  ",GetLastError());
   return(cnt);//    
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
int parser(int Size)
  {
//---    
   for(int i=1;i<Size;i++)
      parser_string(i);
//---           
   return(StrToInteger(s[0]));
  }
//+------------------------------------------------------------------+
//|      x                           |
//+------------------------------------------------------------------+
void parser_string_Symbols(int x)
  {
//---      
   int Len=StringLen(s[x]);
//---      
   int start=0;
//---     ","   
   int end=StringFind(s[x],",",start);
//---      
   int length=end-start;
//---      
   Symbols[x]=StringSubstr(s[x],start,length);
   return;
  }
//+------------------------------------------------------------------+
//|      x                     |
//+------------------------------------------------------------------+
void parser_string(int x)
  {
//---      
   int Len=StringLen(s[x]);
//---   
   int start=7;
//---     ","
   int end=StringFind(s[x],",",start);
//---   
   int length=end-start;
//---   ڨ
   SymPosVol[x]=NormalizeDouble(StrToDouble(StringSubstr(s[x],start,length))*koeff_lot,DigitsMinLot(Symbols[x]));
//---   
   start=end+1;// Type
//---     ","
   end=StringFind(s[x],",",start);
//---   
   length=end-start;
//---   
   SymPosType[x]=StrToInteger(StringSubstr(s[x],start,length));
//---   
   start=end+1;
//---     ","
   end=StringFind(s[x],",",start);
//---   
   length=end-start;
//---   
   SymPosSL[x]=NormalizeDouble(StrToDouble(StringSubstr(s[x],start,length)),digits(Symbols[x]));
//---   
   start=end+1;
//---     ","
   end=StringFind(s[x],",",start);
//---   
   length=end-start;
//---   
   SymPosTP[x]=NormalizeDouble(StrToDouble(StringSubstr(s[x],start,length)),digits(Symbols[x]));
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

